﻿@model  Tuple<string, string, List<SerialsColumnsView>, int>
@{
    bool first = true;
    bool firstDelete = true;
}

<div class="panel-body limitador_shipment_pop ">


    <div class="col-lg-5 no-padding-left ">
        <div class="panel panel-default">
            <div class="panel-heading clearfix">
                <h3 class="panel-title">Free Serials</h3>
            </div>
        </div>
        <table id="SerialsFree" class="table table-striped" style="width:100%;"></table>
    </div>

    <div class="col-lg-2 no-padding" style="padding-top: 100px !important;">
        <a id="" class="btn btn-lg btn-success but_shipment2" onclick=""><span class="glyphicon glyphicon glyphicon-chevron-right "></span></a>
        <div class="clearfix"></div>
        <a id="" class="btn btn-lg btn-success but_shipment2" onclick=""><span class="glyphicon glyphicon glyphicon-chevron-left"></span></a>
    </div>



    <div class="col-lg-5 no-padding-right">
        <div class="panel panel-default">
            <div class="panel-heading clearfix">
                <h3 class="panel-title">Used Serials</h3>
            </div>
        </div>
        <table id="SerialsDoc" class="table table-striped table-hover display" style="width:100%;"></table>
    </div>

</div>



<script>
    var dataColumns;
    var dataColumnsDelete;
        $(document).ready(function () {
            var dataTableDocs;
            var dataTableSAP

            dataColumns = [
                @foreach (var item in Model.Item3)
                {
                    if(first)
                    {
                        first = false;
                        @:{ "data": "@item.data", "title": "@item.title"  }

                    }
                    else
                    {
                        @:,{ "data": "@item.data", "title": "@item.title" }
                    }
                }
                ,{
                    "title": "", "data": null, "width": "110px", "orderable": false, "name": "",
                    "render": function (data, type, full, meta) {
                        var mReturnValue = "<button type=\"button\" class=\"btn btn-primary btn-xs\" onclick=\"Add(" + full.AbsEntry + ",'" + full.DistNumber + "');\"><span class=\"glyphicon glyphicon-arrow-right\"></span> Add</button>";
                        return mReturnValue;
                    }
                }
            ];

             dataColumnsDelete = [
                @foreach (var item in Model.Item3)
                {
                    if(firstDelete)
                    {
                        firstDelete = false;
                        @:{  "data": "@item.data", "title": "@item.title" }

                    }
                    else
                    {
                        @:,{  "data": "@item.data", "title": "@item.title" }
                    }
                }
                ,{
                    "title": "", "data": null, "width": "110px", "orderable": false, "name": "",
                    "render": function (data, type, full, meta) {
                        var mReturnValue = "<button type=\"button\" class=\"btn btn-primary btn-xs\" onclick=\"Delete(" + full.AbsEntry + ",'" + full.DistNumber + "');\"><span class=\"glyphicon glyphicon-arrow-left\"></span> Delete</button>";
                        return mReturnValue;
                    }
                }
            ];

            var populateSAPFree = JSON.parse(('@Model.Item2').replace(/&#39;/g, '"'));
            var populateSAPUsed = JSON.parse(('@Model.Item1').replace(/&#39;/g, '"'));
            //alert(populateSAPFree);
            //alert(populateSAPUsed);
            //Object.keys(dataColumns).forEach(function (key) {

            //    dataColumns[key] = JSON.parse(JSON.stringify(dataColumns[key]).replace(/&#241;/g, 'ñ'));
            //});

            //Object.keys(dataColumnsDelete).forEach(function (key) {
            //    dataColumnsDelete[key] = JSON.parse(JSON.stringify(dataColumnsDelete[key]).replace(/&#241;/g, 'ñ'));
            //});

            PopulateSerialFree(populateSAPFree);

            PopulateSerialsUsed(populateSAPUsed);

        });

    function PopulateSerialFree(json) {

        dataTableSAP = $('#SerialsFree').dataTable({
            data: json,
            "autoWidth": true,
            "processing": true,
            "columns": dataColumns,
            "lengthMenu": [[5], [5]]
            });
        }

    function PopulateSerialsUsed(json) {

        dataTableDocs = $('#SerialsDoc').dataTable({
            data: json,
            "autoWidth": true,
            "processing": true,
            "columns": dataColumnsDelete,
                "lengthMenu": [[5], [5]]
            });
        }

        function Add(AbsEntry, serial) {

            $.ajax({
                url: '/SalesOrder/AddSerial',
                contentType: 'application/json; charset=utf-8',
                type: 'Post',
                data: JSON.stringify({ AbsEntry: AbsEntry, DistNumber: serial, line: '@Model.Item4' }),
                success: function (data) {
                    dataTableSAP.fnDestroy();
                    dataTableDocs.fnDestroy();

                    var objFree = JSON.parse(data[0]);
                    Object.keys(objFree).forEach(function (key) {
                        objFree[key] = JSON.parse(JSON.stringify(objFree[key]).replace('ñ','&#241;'));
                    });

                    var objUsed = JSON.parse(data[1]);
                    Object.keys(objUsed).forEach(function (key) {
                        objUsed[key] = JSON.parse(JSON.stringify(objUsed[key]).replace('ñ','&#241;'));
                    });

                    PopulateSerialFree(objFree);
                    PopulateSerialsUsed(objUsed);
                },
                error: function (jqXHR, exception) {
                }
            });

        }

        function Delete(AbsEntry, serial) {

            $.ajax({
                url: '/SalesOrder/DeleteSerial',
                contentType: 'application/json; charset=utf-8',
                type: 'Post',
                data: JSON.stringify({ AbsEntry: AbsEntry, DistNumber: serial }),
                success: function (data) {
                    dataTableSAP.fnDestroy();
                    dataTableDocs.fnDestroy();

                    var objFree = JSON.parse(data[0]);
                    Object.keys(objFree).forEach(function (key) {
                        objFree[key] = JSON.parse(JSON.stringify(objFree[key]).replace('ñ', '&#241;'));
                    });

                    var objUsed = JSON.parse(data[1]);
                    Object.keys(objUsed).forEach(function (key) {
                        objUsed[key] = JSON.parse(JSON.stringify(objUsed[key]).replace('ñ', '&#241;'));
                    });

                    PopulateSerialFree(objFree);
                    PopulateSerialsUsed(objUsed);
                },
                error: function (jqXHR, exception) {
                }
            });

    }



</script>

